
#include "V3.h"
#include "M33.h"

using namespace std;

#include <ostream>

V3::V3(float x, float y, float z) {

	xyz[0] = x;
	xyz[1] = y;
	xyz[2] = z;

}

float& V3::operator[](int i) {

	return xyz[i];

}

V3 V3::operator+(V3 op1) {

	V3 ret;
	V3 &op0 = (*this);
	ret[0] = op0[0] + op1[0];
	ret[1] = op0[1] + op1[1];
	ret[2] = op0[2] + op1[2];
	return ret;

}

V3 V3::operator-(V3 op1) {

	V3 ret;
	V3 &op0 = (*this);
	ret[0] = op0[0] - op1[0];
	ret[1] = op0[1] - op1[1];
	ret[2] = op0[2] - op1[2];
	return ret;

}

float V3::operator*(V3 op1) {

	V3 &op0 = (*this);
	float ret;
	ret = op0[0] * op1[0] + op0[1] * op1[1] + op0[2] * op1[2];
	return ret;

}

V3 V3::operator/(float scf) {

	V3& v = *this;
	return v * (1.0f / scf);

}

V3 V3::operator*(float scf) {

	V3 ret;
	V3& v = *this;
	ret[0] = v[0] * scf;
	ret[1] = v[1] * scf;
	ret[2] = v[2] * scf;
	return ret;

}


V3 V3::operator^(V3 v2) {
	// y1z2 - z1y2
	// z1x2 - x1z2
	// x1y2 - y1x2

	V3 &v1 = *this;
	V3 ret;
	ret[0] = v1[1] * v2[2] - v1[2] * v2[1];
	ret[1] = v1[2] * v2[0] - v1[0] * v2[2];
	ret[2] = v1[0] * v2[1] - v1[1] * v2[0];
	return ret;

}